Unit Num6x6;

Interface

Procedure NUM6x6_Init;
Procedure NUM6x6_Draw(X,Y:Word;N:LongInt;Color:Byte);
Procedure Num6x6_Done;

Implementation

Uses HHG, VGA_A;

Var
  Numbers : TImageFile;

Procedure NUM6x6_Init;
  begin
    HHG_Load('NUM6X6.HHG', Numbers);
  end;

Procedure NUM6x6_Draw_Ch(X,Y:Word;N:Byte;Color:Byte);
  begin
    VGA_PutImage_Trans(X, Y, Numbers.Images[N+Color*10]^, 6, 6);
  end;

Procedure Num6x6_Draw(X,Y:Word; N:LongInt;Color:Byte);
var
  S : String[8];
  I : Byte;
  begin
    Str(N, S);
    For I := 1 to Length(S) do
      begin
        NUM6x6_Draw_Ch(X, Y, Byte(S[I])-48, Color);
        Inc(X, 6);
      end;
  end;

Procedure Num6x6_Done;
  begin
    HHG_FreeMem(Numbers);
  end;


end.