{$G+}
unit VGA_A; {An addition for VGA unit}
{*****************************************************}
{ (C) The Cat                                         }
{*****************************************************}

interface

uses VGA;

const
  BytesPerLine = 320; {   ਧ⠫ }

                 {  뢮   .. ࠩ   }
                 {                  ࠧ                 }
  Procedure  VGA_PutImage(x,y : word;var Image;const width, height : word); {  ஧筮 }
  Procedure  VGA_PutImage_Trans(x,y : word;var Image;const width, height : word); {  ஧筮 }
  Procedure  VGA_PutImage_Shade(x,y : word;
                                var Image;
                                const width, height : word;
                                const shade : byte);
  Procedure  VGA_PutImage_Color(x,y : word;
                                var Image;
                                const width, height : word;
                                const color : byte);

  Procedure  VGA_ClearDevice; {  (32bit) }
  Procedure  VGA_RestorePalette(palette : VGA_Palette); {         }
  Procedure  VGA_SavePalette(var palette : VGA_Palette);{ ॥ !!!}

implementation

Procedure  VGA_PutImage(x,y : word;var Image;const width, height : word);assembler;
Asm
   cld
   mov  ax,y
   xchg ah,al
   mov  bx,x
   add  bx,ax
   shr  ax,2
   add  bx,ax  { bx = y*320+x }
   les  di,Double_Buffer
   add  di,bx  {es:[di] - Video}
   mov  dx,width { ࠧ }
   mov  ax,height { ࠩ }
   mov  bx,BytesPerLine  { 320 }
    push ds
        lds  si,Image
        sub  bx,dx
      @L1:
        mov  cx,dx
        rep  movsb
        add  di,bx
        dec  ax
      jnz @L1
    pop ds
End;

Procedure  VGA_PutImage_Trans(x,y : word;var Image;const width, height : word);assembler;
Asm
   cld
   mov  ax,y
   xchg ah,al
   mov  bx,x
   add  bx,ax
   shr  ax,2
   add  bx,ax  { bx = y*320+x }
   les  di,Double_Buffer
   add  di,bx  {es:[di] - Video}
   mov  dx,width { ࠧ }
   mov  ax,height { ࠩ }
   mov  bx,BytesPerLine  { 320 }
    push ds
        lds  si,Image
        sub  bx,dx
      @L1:
        mov  cx,dx
         @L2:
           push  ax
           lodsb
           cmp  al,0 { 0 - ஧筮 }
           jz @Proz
             stosb
             jmp  @l03
           @Proz:
             inc  di
           @L03:
          pop  ax
          dec  cx
        jnz  @L2
        add  di,bx
        dec  ax
      jnz  @L1
    pop  ds
End;

{Bit-blitting procedure
 Modified by The Inquisitor from
 Tha Cat's VGA_PutImage_Trans
}
Procedure  VGA_PutImage_Shade(x,y : word;
                              var Image;
                              const width, height : word;
                              const shade : byte);assembler;
Asm
   cld
   mov  ax,y
   xchg ah,al
   mov  bx,x
   add  bx,ax
   shr  ax,2
   add  bx,ax  { bx = y*320+x }
   les  di,Double_Buffer
   add  di,bx  {es:[di] - Video}
   mov  dx,width { ࠧ }
   mov  ax,height { ࠩ }
   mov  bx,BytesPerLine  { 320 }
    push ds
        lds  si,Image
        sub  bx,dx
      @L1:
        mov  cx,dx
         @L2:
           push  ax
           lodsb
           cmp  al,0 { 0 - ஧筮 }
           jz @Proz

             {Shade handle}
             add al, shade
             cmp al, 0
             je @set_zero
             jmp @bypass_set_zero
             @set_zero:
             xor al, al
             @bypass_set_zero:

             stosb
             jmp  @l03
           @Proz:
             inc  di
           @L03:
          pop  ax
          dec  cx
        jnz  @L2
        add  di,bx
        dec  ax
      jnz  @L1
    pop  ds
End;

Procedure  VGA_PutImage_Color(x,y : word;
                              var Image;
                              const width, height : word;
                              const color : byte);assembler;
Asm
   cld
   mov  ax,y
   xchg ah,al
   mov  bx,x
   add  bx,ax
   shr  ax,2
   add  bx,ax  { bx = y*320+x }
   les  di,Double_Buffer
   add  di,bx  {es:[di] - Video}
   mov  dx,width { ࠧ }
   mov  ax,height { ࠩ }
   mov  bx,BytesPerLine  { 320 }
    push ds
        lds  si,Image
        sub  bx,dx
      @L1:
        mov  cx,dx
         @L2:
           push  ax
           lodsb
           cmp  al,0 { 0 - ஧筮 }
           jz @Proz

           {Color fill}
           xor al, al
           add al, color

             stosb
             jmp  @l03
           @Proz:
             inc  di
           @L03:
          pop  ax
          dec  cx
        jnz  @L2
        add  di,bx
        dec  ax
      jnz  @L1
    pop  ds
End;


Procedure  VGA_ClearDevice;assembler;
 Asm
  les  di,Double_Buffer { 㪠⥫  Video }

     db 066h     { xor Ecx,Ecx  }
     xor cx,cx   {              }

  mov  cx,320*50   {             }

     db 066h       { xor Eax,Eax }
     xor  ax,ax    {             }

(*   db 066h        { mov Eax,10101010h }
     mov ax,1010h  {  ஢  }
     dw 1010h*)

  db 066h     { rep stosd }
  rep  stosw  {           }
end;

Procedure  VGA_RestorePalette(palette : VGA_Palette);assembler;
 Asm
   push ds
    lds si,palette
    xor al,al
    mov dx,03C8h
    out dx,al
    mov cx,3*256
    inc dx
    rep outsb
   pop ds
End;

Procedure  VGA_SavePalette(var palette : VGA_Palette);assembler;
 Asm
   push ds
    les di,palette
    xor al,al
    mov dx,03C7h
    out dx,al
    mov cx,256*3
    add dx,2
    rep outsb
   pop ds
End;

end.